package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.bpel.model.*;
import org.eclipse.bpel.model.Process;
import org.eclipse.bpel.model.partnerlinktype.Role;
import org.spagic.bpel.ode.utils.*;
import org.spagic.bpel.ode.DeployActivator;

public class _jet_wsdl implements JET2Template {

    public _jet_wsdl() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    

	Process process = (Process)context.getSource();
	String processName = process.getName();
	String absPathBpel = (String)context.getVariable("org.spagic.bpel.ode.absPathBpel");

        out.write(WsdlParserUtil.getPartialWsdlWrappedContent(absPathBpel, processName + "Artifacts.wsdl"));
        out.write(NL);         
        out.write(NL);         
 	
	String targetNamespace = process.getTargetNamespace();
	String processUri = (String)context.getVariable("org.spagic.bpel.ode.processUri");
	
	PartnerLinks partnerLinks = process.getPartnerLinks();
	WsdlParserUtil wsdlParser = (WsdlParserUtil)context.getVariable("wsdlParser");
	String portType = "";
	/**** simplification: retrieve the first partnerLink with myRole != null *******/
	for (PartnerLink partnerLink : partnerLinks.getChildren()) {
		Role myRole = partnerLink.getMyRole();
		if ( myRole != null ) {
			portType = wsdlParser.getPortTypeByMyRole(partnerLink.getName(), myRole.getName());
			if (portType == null) 
				throw new RuntimeException();
			break;
		}
		
	}

        out.write("\t<wsdlBind:binding name=\"");  //$NON-NLS-1$        
        out.write(processName);
        out.write("SOAPBinding\" type=\"");  //$NON-NLS-1$        
        out.write(portType);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t    <soap:binding style=\"doc\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttransport=\"http://schemas.xmlsoap.org/soap/http\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t    <wsdlBind:operation name=\"process\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<soap:operation  soapAction=\"\" style=\"doc\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<wsdlBind:input>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t        \t<soap:body namespace=\"");  //$NON-NLS-1$        
        out.write(targetNamespace);
        out.write("\" use=\"literal\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      \t</wsdlBind:input>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      \t<wsdlBind:output>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t        \t<soap:body namespace=\"");  //$NON-NLS-1$        
        out.write(targetNamespace);
        out.write("\" use=\"literal\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      \t</wsdlBind:output>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t    </wsdlBind:operation>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t</wsdlBind:binding>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t<wsdlBind:service name=\"");  //$NON-NLS-1$        
        out.write(processName);
        out.write("SOAPService\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t<wsdlBind:port name=\"");  //$NON-NLS-1$        
        out.write(processName);
        out.write("\" binding=\"tns:");  //$NON-NLS-1$        
        out.write(processName);
        out.write("SOAPBinding\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<soap:address location=\"");  //$NON-NLS-1$        
        out.write(processUri);
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t<!-- Connect this external HTTP endpoint to the process internal ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                 JBI endpoint defined in HelloWorld2-process/HelloWorld2.dd -->");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            <smix:endpoint role=\"consumer\" defaultMep=\"in-out\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t</wsdlBind:port>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t</wsdlBind:service>        ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</definitions>");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
