package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBISMBean implements JET2Template {
    private static final String _jetns_ws = "org.eclipse.jet.workspaceTags"; //$NON-NLS-1$

    public _jet_JBISMBean() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_ws_copyFile_96_2 = new TagInfo("ws:copyFile", //$NON-NLS-1$
            96, 2,
            new String[] {
                "src", //$NON-NLS-1$
                "srcContext", //$NON-NLS-1$
                "target", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/{$relativeFileNameToProject}", //$NON-NLS-1$
                "workspace", //$NON-NLS-1$
                "{$relativeFileNameToServiceUnit}", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	ServiceBinding binding = JBIJetUtils.getRightStepBinding(aStep);
	String referredBean = SpagicUtils.getStepLocalNamePart(aProcess, aStep) + "Bean";

        out.write(NL);         
        out.write("<bean:endpoint  service=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tbean=\"#");  //$NON-NLS-1$        
        out.write(referredBean);
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("<bean id=\"");  //$NON-NLS-1$        
        out.write(referredBean);
        out.write("\" class=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getBeanClassForServiceBinding(binding,aStep));
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
 
	   	   List<IPropertyMap> configuredProperties = JBIJetUtils.getCodeGeneratorPropertyMap(binding);
	   	   String pSection = null;
	   	   for (IPropertyMap pMap : configuredProperties ) {
	   	   		pSection = pMap.eval(aStep);

        out.write("\t   \t   \t\t");  //$NON-NLS-1$        
        out.write(pSection);
        out.write(NL);         

	   	   	}


		  if (JBIJetUtils.isRequiredNamespaceMapForBinding(binding)){
		  		 Map<String, String> namespaceMap = JBIJetUtils.getNamespaceMap();

        out.write("\t\t\t<property name=\"namespaceMap\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<map>");  //$NON-NLS-1$        
        out.write(NL);         
	
			for ( String prefixNs : namespaceMap.keySet()){

        out.write("\t\t\t\t<entry key=\"");  //$NON-NLS-1$        
        out.write(prefixNs);
        out.write("\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t<value>");  //$NON-NLS-1$        
        out.write(namespaceMap.get(prefixNs));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t</entry> \t\t");  //$NON-NLS-1$        
        out.write(NL);         
		
			}

        out.write("\t\t\t\t</map>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</property>");  //$NON-NLS-1$        
        out.write(NL);         

		}


		  if ((JBIJetUtils.injectDestinationAsExchangeTarget(binding)) && (destinationStep != null)){

        out.write("\t\t\t<property name=\"target\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<bean class=\"org.apache.servicemix.bean.support.ExchangeTarget\">");  //$NON-NLS-1$        
        out.write(NL);         

					 String destinationUri = "service:" + SpagicUtils.getNameSpaceForProcess(aProcess) + ":" + SpagicUtils.getStepLocalNamePart(aProcess,destinationStep);

        out.write("\t\t\t\t\t<property name=\"uri\" value=\"");  //$NON-NLS-1$        
        out.write(destinationUri);
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</property>");  //$NON-NLS-1$        
        out.write(NL);         

		}

        out.write("</bean>");  //$NON-NLS-1$        
        out.write(NL);         
 for (CopyResource copyResource : JBIJetUtils.getCodeGeneratorCopyResources(binding)) { 
    String fileNameRelativeToProject = JBIJetUtils.getRequiredPropertyValue(aStep, copyResource.getImProperty());
	context.setVariable("relativeFileNameToProject", fileNameRelativeToProject);
	context.setVariable("relativeFileNameToServiceUnit", JBIJetUtils.getRelativeFileName(fileNameRelativeToProject));

        out.write("\t");  //$NON-NLS-1$        
        RuntimeTagElement _jettag_ws_copyFile_96_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "copyFile", "ws:copyFile", _td_ws_copyFile_96_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_copyFile_96_2.setRuntimeParent(null);
        _jettag_ws_copyFile_96_2.setTagInfo(_td_ws_copyFile_96_2);
        _jettag_ws_copyFile_96_2.doStart(context, out);
        _jettag_ws_copyFile_96_2.doEnd();
        out.write(NL);         
 } 
    }
}
