package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardFTP implements JET2Template {

    public _jet_JBIStandardFTP() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String endpointType = "poller";
	if (bindingName.equalsIgnoreCase("JBI-FTP-PollerBindingComponent")){
   		endpointType = "poller";
   	}else if (bindingName.equalsIgnoreCase("JBI-FTP-WriterBindingComponent")) {
   		endpointType = "sender";
   	}
   	
   	boolean isEventHandler = bindingName.equalsIgnoreCase("FTPEventBindingComponent");
   	
	String marshallerValue = "defaultFileMarshaler";
	
	String marshallerPropertyValue = JBIJetUtils.getOptionalPropertyValue(aStep,"Marshaller","DefaultFileMarshaller");

	if (marshallerPropertyValue.equalsIgnoreCase("BinaryFileMarshaller")){
		marshallerValue = "binaryFileMarshaler";
	}
	
	if (isEventHandler){
		marshallerValue = "eventMarshaller";
	}
	
	String binaryContentType=JBIJetUtils.getOptionalPropertyValue(aStep,"binaryContentType","text/plain");
	
	
	
	
	String ftpHost 		=  JBIJetUtils.getRequiredPropertyValue(aStep,"Host");
	String ftpPort 		=  JBIJetUtils.getOptionalPropertyValue(aStep,"Port" ,"21");
	String ftpUser		=  JBIJetUtils.getOptionalPropertyValue(aStep,"User" ,"anonymous");
	String ftpPassword	=	JBIJetUtils.getOptionalPropertyValue(aStep,"Password" ,null);
	String ftpFolder	=	JBIJetUtils.getOptionalPropertyValue(aStep,"Folder" ,"");
	
	if (ftpUser.equalsIgnoreCase("anonymous")){
		ftpPassword = "anonymous@anonymous.com";
	}
	String ftpUri = "ftp://"+ftpUser+(ftpPassword!=null ? ":"+ftpPassword : "")+"@"+ftpHost+":"+ftpPort+"/"+ftpFolder;

        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         

if (endpointType.equalsIgnoreCase("poller")){

        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\turi=\"");  //$NON-NLS-1$        
        out.write(ftpUri);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdeleteFile=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FlagDeletePolledFile", "true"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
       if (!isEventHandler){ 
        out.write("\t\t\t<ftp:marshaler>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
 if (marshallerValue.equalsIgnoreCase("binaryFileMarshaler")){
        out.write("\t\t\t\t\t\t<sm:contentType>");  //$NON-NLS-1$        
        out.write(binaryContentType);
        out.write("</sm:contentType>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t</sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</ftp:marshaler>\t\t");  //$NON-NLS-1$        
        out.write(NL);         
       } else {   
        out.write("\t\t\t<property name=\"filter\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t<bean class=\"org.spagic.event.file.filter.SpagicFileEventFilter\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t<property name=\"filterRules\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t<map>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"ExtensionIs\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "ExtensionIs","*"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t<entry key=\"FileNameStartWith\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileNameStartWith","*"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>  \t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"FileNameEndWith\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileNameEndWith","*"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"FileMinLength\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileMinLength","0"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"FileMaxLength\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileMaxLength",""));
        out.write("</value>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t</map>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t</property> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t</property>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<property name=\"marshaler\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t<bean class=\"org.spagic.event.file.marshaller.SpagicFileEventDynamicMarshaller\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t\t<property name=\"signalEndpointURI\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t\t\t\t\t\t\tvalue=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t</property>");  //$NON-NLS-1$        
        out.write(NL);         
       } 
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
} else {
        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\turi=\"");  //$NON-NLS-1$        
        out.write(ftpUri);
        out.write("\"\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
 if (marshallerValue.equalsIgnoreCase("defaultFileMarshaler")){
        out.write("\t\t \t<ftp:marshaler>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t</sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</ftp:marshaler>\t");  //$NON-NLS-1$        
        out.write(NL);         
}else if (marshallerValue.equalsIgnoreCase("binaryFileMarshaler")) {
        out.write("\t\t \t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t \t <property name=\"marshaler\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t\t\t<bean class=\"org.apache.servicemix.components.util.LenientBinaryFileMarshaler\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t\t\t\t<property name=\"contentType\" value=\"");  //$NON-NLS-1$        
        out.write(binaryContentType);
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t\t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t\t </property>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
}
    }
}
