package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardMail implements JET2Template {

    public _jet_JBIStandardMail() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String endpointType = "poller";
	if (bindingName.equalsIgnoreCase("JBI-AdvancedEmailInputBindingComponent")){
   		endpointType = "poller";
   	}else if (bindingName.equalsIgnoreCase("JBI-AdvancedEmailSender")) {
   		endpointType = "sender";
   	}
   
	String mailUri = null;
	
	String mailHost 	=  JBIJetUtils.getRequiredPropertyValue(aStep,"Host");
	String mailPort 	=  JBIJetUtils.getOptionalPropertyValue(aStep,"Port" ,"25");
	String mailUser		=  JBIJetUtils.getOptionalPropertyValue(aStep,"User" ,"anonymous");
	String mailPassword	=  JBIJetUtils.getOptionalPropertyValue(aStep,"Password" ,null);
	String mailProtocol	=  JBIJetUtils.getOptionalPropertyValue(aStep,"Protocol" ,"imap");
	String useTLS	=  JBIJetUtils.getOptionalPropertyValue(aStep,"UseTLS" ,"false");
	String useSSL = JBIJetUtils.getOptionalPropertyValue(aStep,"UseSSL" ,"false");
	String mailMarshaler = JBIJetUtils.getOptionalPropertyValue(aStep,"Marshaler" ,"DefaultMailMarshaler");

	String mailSender		=  JBIJetUtils.getOptionalPropertyValue(aStep, "MailFrom", null);
	String mailReceiver		=  JBIJetUtils.getOptionalPropertyValue(aStep, "MailTo", null);
	String mailSubject		=  JBIJetUtils.getOptionalPropertyValue(aStep, "Subject", null);
	
	
	if (mailUser.equalsIgnoreCase("anonymous")){
		mailPassword = "anonymous@anonymous.com";
	}
	
	if (endpointType.equalsIgnoreCase("sender")){
		mailProtocol = "smtp";
	}
	
	
	if (useSSL.equalsIgnoreCase("true")){
		mailProtocol += "s";
	}
	
	mailUri = mailProtocol+"://"+mailHost+":"+mailPort+"?user="+mailUser+";password="+mailPassword;

        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tconnection=\"");  //$NON-NLS-1$        
        out.write(mailUri);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tstartTLS=\"");  //$NON-NLS-1$        
        out.write(useTLS);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         

if (endpointType.equalsIgnoreCase("poller")){

        out.write("\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tperiod=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"Period"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tdeleteProcessedMessages=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    processOnlyUnseenMessages=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
} else {
		if (mailReceiver != null) {
        out.write("\t\t\treceiver=\"");  //$NON-NLS-1$        
        out.write(mailReceiver);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
}
		if ((mailSender != null) && (mailSender.trim().length() != 0)) {
        out.write("\t\t\tsender=\"");  //$NON-NLS-1$        
        out.write(mailSender);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
}
		if ((mailSubject != null) && (mailSubject.trim().length() != 0)) {
        out.write("\t\t\tsubject=\"");  //$NON-NLS-1$        
        out.write(mailSubject);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
}
}
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("<property name=\"marshaler\">");  //$NON-NLS-1$        
        out.write(NL);         
 String marshalerClass = "org.apache.servicemix.mail.marshaler.GenericTextMailMarshaler";
	   if (mailMarshaler.equalsIgnoreCase("DefaultMailMarshaler")) { 
			marshalerClass = "org.apache.servicemix.mail.marshaler.DefaultMailMarshaler";
	   } else if (mailMarshaler.equalsIgnoreCase("PECMailMarshaler")) {
			marshalerClass ="org.spagic.mail.custom.marshaller.PECMarshaller";
	   } else {
			marshalerClass = "org.apache.servicemix.mail.marshaler.GenericTextMailMarshaler";
	   } 
        out.write("    <bean class=\"");  //$NON-NLS-1$        
        out.write(marshalerClass);
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</property>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
