package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.xmi.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import java.util.*;
import java.io.StringWriter;
import java.io.IOException;
import org.spagic.utils.*;
import org.spagic.utils.graph.*;
import org.spagic.utils.preference.SpagicPreferenceConstants;
import org.spagic.im.out.jbi.smx.utils.*;
import org.hibernate.cfg.Configuration;
import org.hibernate.Session;
import org.hibernate.criterion.Expression;
import org.hibernate.HibernateException;
import org.spagic.metadb.model.XmlNamespace;
import java.util.List;
import java.util.HashMap;
import java.util.Iterator;

public class _jet_deploy implements JET2Template {

    public _jet_deploy() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    
        out.write("<?xml version=\"1.0\" encoding=\"utf-8\"?>");  //$NON-NLS-1$        
        out.write(NL);         

	StpIntermediateModel stpModel = (StpIntermediateModel)(context.getVariable("stpModel"));
	String graphVizExeLocation = (String)context.getVariable("graphVizExeLocation");
	String graphVizTempFolder = (String)context.getVariable("graphVizTempFolder");
	String baseNamespace = (String)context.getVariable("baseNamespace");
	List<org.eclipse.stp.im.Process> processesList = stpModel.getProcessCollection().getProcesses();

        out.write("<DEPLOY>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<BASE_NAMESPACE>");  //$NON-NLS-1$        
        out.write(baseNamespace);
        out.write("</BASE_NAMESPACE>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<NAMESPACES> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<NAMESPACES_REPOSITORY> ");  //$NON-NLS-1$        
        out.write(NL);         
		
		//open hibernate session
		Session session = null;
		try{
			Configuration cfg = new Configuration().configure();
			org.eclipse.core.runtime.Preferences prefs = SpagicUtilsActivator.getDefault().getPluginPreferences();
			String dbUrl = prefs.getString(SpagicPreferenceConstants.P_SPAGIC_DB_URL);
			String dbDriver = prefs.getString(SpagicPreferenceConstants.P_SPAGIC_DB_DRIVER);
			String dbUser = prefs.getString(SpagicPreferenceConstants.P_SPAGIC_DB_USER);
			String dbPassword = prefs.getString(SpagicPreferenceConstants.P_SPAGIC_DB_PASSWORD);
			String dbDialect = prefs.getString(SpagicPreferenceConstants.P_SPAGIC_DB_HIB_DIALECT);
			String dbShowSql = prefs.getString(SpagicPreferenceConstants.P_SPAGIC_DB_SHOW_SQL);
	        cfg.setProperty("hibernate.connection.driver_class", dbDriver);
	        cfg.setProperty("hibernate.connection.url",dbUrl);
	        cfg.setProperty("hibernate.connection.username",dbUser);
	        cfg.setProperty("hibernate.connection.password",dbPassword);
	        cfg.setProperty("hibernate.dialect",dbDialect);
	        cfg.setProperty("hibernate.show_sql",dbShowSql);
			session = cfg.buildSessionFactory().openSession();
			List<Step> stepList = null;
			Map<String, String> nameSpacePrefixMap = new HashMap<String, String>();
			String colonSeparator = ":";
			String slashSeparator = "/";
			int indexPrefix, indexSlash;
			
			//cycle for all observable atributes of all steps of all processes
			//retrieve the prefix namespaces and put them into a hashmap  
			for ( org.eclipse.stp.im.Process aProcess : processesList){
				stepList = aProcess.getSteps();
				for (Step step : stepList) {
					List<ObservableAttribute> observableAttributes = step.getObservableAttributes();
					for (ObservableAttribute observableAttribute : observableAttributes) {
						ExtractDataRule dataRule = observableAttribute.getObservableAttributeExtractRule();
						String expression = dataRule.getExpression();
						while (expression.contains(colonSeparator)){
							indexPrefix = expression.indexOf(colonSeparator);
							indexSlash = expression.lastIndexOf(slashSeparator, indexPrefix);
							String prefix = expression.substring(indexSlash + 1, indexPrefix);
							XmlNamespace xmlNamespace = (XmlNamespace)session.createCriteria(XmlNamespace.class).add(Expression.eq("prefix", prefix)).uniqueResult(); 	
							nameSpacePrefixMap.put(prefix, xmlNamespace.getValue());
							expression = expression.substring(indexPrefix + 1);
						}
					}
				}//end for stepList
			}//end for processList	
			
			
			for (String  prefix : nameSpacePrefixMap.keySet()){

        out.write("<NAMESPACE name=\"");  //$NON-NLS-1$        
        out.write(prefix);
        out.write("\" value=\"");  //$NON-NLS-1$        
        out.write(nameSpacePrefixMap.get(prefix));
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
			}
		}catch(HibernateException he){
			
		}finally{
			session.close();
		}

        out.write("</NAMESPACES_REPOSITORY>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</NAMESPACES> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<OBSERVABLE_ATTRIBUTE_REPOSITORY>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.removeXMLHeader(JBIJetUtils.getObservableAttributeXML(processesList)));
        out.write(NL);         
        out.write("</OBSERVABLE_ATTRIBUTE_REPOSITORY>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<INTERMEDIATE_MODEL>");  //$NON-NLS-1$        
        out.write(NL);         

	Resource res = (Resource)context.getSource();

    Map<String, String> options = new HashMap<String, String>();
    //change as needed according to the type of resource
    //you are using
	options.put(XMIResource.OPTION_ENCODING, "UTF-8");
 
	StringWriter sw = new StringWriter();
	URIConverter.WriteableOutputStream uws = new URIConverter.WriteableOutputStream(sw, "UTF-8");
	try{
		res.save(uws, options);
	}catch(IOException e){
		throw new RuntimeException(e);
	}

        out.write(JBIJetUtils.removeXMLHeader(sw.toString()));
        out.write("</INTERMEDIATE_MODEL>");  //$NON-NLS-1$        
        out.write(NL);         

	for ( org.eclipse.stp.im.Process aProcess : processesList){
	
		if (SpagicUtils.isProcessDeployableForRuntime(
			aProcess, JBIJetUtils.getRuntimeId())){
			String processGraph = GraphGenerator.getGraphForProcess(aProcess,
					graphVizExeLocation, graphVizTempFolder);
			
			
        out.write("<PROCESS>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<GRAPH>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(JBIJetUtils.removeXMLHeader(processGraph));
        out.write("</GRAPH>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</PROCESS>");  //$NON-NLS-1$        
        out.write(NL);         

		}
	}

        out.write("</DEPLOY>");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
